# Class ConstantMethodHandle

java.lang.Object
org.apache.bcel.classfile.Constant
org.apache.bcel.classfile.ConstantMethodHandle

All Implemented Interfaces:
  `Cloneable, Node`

public final class ConstantMethodHandle extends Constant
This class is derived from the abstract `Constant` and represents a reference to a method handle.

Since:
  6.0
See Also:
  - `Constant`

- ## Field Summary

  ### Fields inherited from class Constant

  `tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ConstantMethodHandle(int referenceKind, int referenceIndex)`
  Constructs a ConstantMethodHandle.
  `ConstantMethodHandle(ConstantMethodHandle c)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `void`
  `dump(DataOutputStream file)`
  Dumps method kind and index to file stream in binary format.
  `int`
  `getReferenceIndex()`
  Gets the reference index.
  `int`
  `getReferenceKind()`
  Gets the reference kind.
  `void`
  `setReferenceIndex(int referenceIndex)`
  Sets the reference index.
  `void`
  `setReferenceKind(int referenceKind)`
  Sets the reference kind.
  `String`
  `toString()`

  ### Methods inherited from class Constant

  `clone, copy, equals, getComparator, getTag, hashCode, readConstant, setComparator`

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ConstantMethodHandle

    public ConstantMethodHandle(ConstantMethodHandle c)
    Initialize from another object.
    Parameters:
      `c` - Source to copy.

  - ### ConstantMethodHandle

    public ConstantMethodHandle(int referenceKind, int referenceIndex)
    Constructs a ConstantMethodHandle.
    Parameters:
      `referenceKind` - Kind of method reference.
      `referenceIndex` - Index to the method reference.

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Constant`
    Parameters:
      `v` - Visitor object.

  - ### dump

    public void dump(DataOutputStream file) throws IOException
    Dumps method kind and index to file stream in binary format.
    Specified by:
      `dump` in class `Constant`
    Parameters:
      `file` - Output file stream.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### getReferenceIndex

    public int getReferenceIndex()
    Gets the reference index.
    Returns:
      the reference index.

  - ### getReferenceKind

    public int getReferenceKind()
    Gets the reference kind.
    Returns:
      the reference kind.

  - ### setReferenceIndex

    public void setReferenceIndex(int referenceIndex)
    Sets the reference index.
    Parameters:
      `referenceIndex` - the reference index.

  - ### setReferenceKind

    public void setReferenceKind(int referenceKind)
    Sets the reference kind.
    Parameters:
      `referenceKind` - the reference kind.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Constant`
    Returns:
      String representation.